package repository

import (
	"strings"
	"time"

	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/utils/repo"
	"be.ems/src/modules/network_element/model"
)

// 实例化数据层 NeVersion 结构体
var NewNeVersion = &NeVersion{
	selectSql: `select 
	id, ne_type, ne_id, name, version, path, pre_name, pre_version, pre_path, new_name, new_version, new_path, status, create_by, create_time, update_by, update_time 
	from ne_version`,

	resultMap: map[string]string{
		"id":          "ID",
		"ne_type":     "NeType",
		"ne_id":       "NeId",
		"name":        "name",
		"version":     "Version",
		"path":        "Path",
		"pre_name":    "preName",
		"pre_version": "PreVersion",
		"pre_path":    "PrePath",
		"new_name":    "NewName",
		"new_version": "NewVersion",
		"new_path":    "NewPath",
		"status":      "Status",
		"create_by":   "CreateBy",
		"create_time": "CreateTime",
		"update_by":   "UpdateBy",
		"update_time": "UpdateTime",
	},
}

// NeVersion 网元版本信息 数据层处理
type NeVersion struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *NeVersion) convertResultRows(rows []map[string]any) []model.NeVersion {
	arr := make([]model.NeVersion, 0)
	for _, row := range rows {
		item := model.NeVersion{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// SelectPage 根据条件分页查询字典类型
func (r *NeVersion) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["neType"]; ok && v != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["neId"]; ok && v != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["version"]; ok && v != "" {
		conditions = append(conditions, "version like concat(?, '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["path"]; ok && v != "" {
		conditions = append(conditions, "path like concat(?, '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.NeHost{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from ne_version"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " order by update_time desc limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 查询数据
	querySql := r.selectSql + whereSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return result
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *NeVersion) SelectList(neVersion model.NeVersion) []model.NeVersion {
	// 查询条件拼接
	var conditions []string
	var params []any
	if neVersion.NeType != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, neVersion.NeType)
	}
	if neVersion.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, neVersion.NeId)
	}
	if neVersion.Version != "" {
		conditions = append(conditions, "version like concat(?, '%')")
		params = append(params, neVersion.Version)
	}
	if neVersion.Path != "" {
		conditions = append(conditions, "path like concat(?, '%')")
		params = append(params, neVersion.Path)
	}
	if neVersion.Status != "" {
		conditions = append(conditions, "status = ?")
		params = append(params, neVersion.Status)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by id asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIds 通过ID查询
func (r *NeVersion) SelectByIds(cmdIds []string) []model.NeVersion {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	querySql := r.selectSql + " where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.RawDB("", querySql, parameters)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return []model.NeVersion{}
	}
	// 转换实体
	return r.convertResultRows(results)
}

// Insert 新增信息
func (r *NeVersion) Insert(neVersion model.NeVersion) string {
	// 参数拼接
	params := make(map[string]any)
	if neVersion.NeType != "" {
		params["ne_type"] = neVersion.NeType
	}
	if neVersion.NeId != "" {
		params["ne_id"] = neVersion.NeId
	}
	if neVersion.Name != "" {
		params["name"] = neVersion.Name
	}
	if neVersion.Version != "" {
		params["version"] = neVersion.Version
	}
	if neVersion.Path != "" {
		params["path"] = neVersion.Path
	}
	if neVersion.PreName != "" {
		params["pre_name"] = neVersion.PreName
	}
	if neVersion.PreVersion != "" {
		params["pre_version"] = neVersion.PreVersion
	}
	if neVersion.PrePath != "" {
		params["pre_path"] = neVersion.PrePath
	}
	if neVersion.NewName != "" {
		params["new_name"] = neVersion.NewName
	}
	if neVersion.NewVersion != "" {
		params["new_version"] = neVersion.NewVersion
	}
	if neVersion.NewPath != "" {
		params["new_path"] = neVersion.NewPath
	}
	if neVersion.Status != "" {
		params["status"] = neVersion.Status
	}
	if neVersion.CreateBy != "" {
		params["create_by"] = neVersion.CreateBy
		params["create_time"] = time.Now().UnixMilli()
	}

	// 构建执行语句
	keys, placeholder, values := repo.KeyPlaceholderValueByInsert(params)
	sql := "insert into ne_version (" + strings.Join(keys, ",") + ")values(" + placeholder + ")"

	db := datasource.DefaultDB()
	// 开启事务
	tx := db.Begin()
	// 执行插入
	err := tx.Exec(sql, values...).Error
	if err != nil {
		logger.Errorf("insert row : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 获取生成的自增 ID
	var insertedID string
	err = tx.Raw("select last_insert_id()").Row().Scan(&insertedID)
	if err != nil {
		logger.Errorf("insert last id : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 提交事务
	tx.Commit()
	return insertedID
}

// Update 修改信息
func (r *NeVersion) Update(neVersion model.NeVersion) int64 {
	// 参数拼接
	params := make(map[string]any)
	if neVersion.NeType != "" {
		params["ne_type"] = neVersion.NeType
	}
	if neVersion.NeId != "" {
		params["ne_id"] = neVersion.NeId
	}
	if neVersion.Name != "" {
		params["name"] = neVersion.Name
	}
	if neVersion.Version != "" {
		params["version"] = neVersion.Version
	}
	if neVersion.Path != "" {
		params["path"] = neVersion.Path
	}
	if neVersion.PreName != "" {
		params["pre_name"] = neVersion.PreName
	}
	if neVersion.PreVersion != "" {
		params["pre_version"] = neVersion.PreVersion
	}
	if neVersion.PrePath != "" {
		params["pre_path"] = neVersion.PrePath
	}
	if neVersion.NewName != "" {
		params["new_name"] = neVersion.NewName
	}
	if neVersion.NewVersion != "" {
		params["new_version"] = neVersion.NewVersion
	}
	if neVersion.NewPath != "" {
		params["new_path"] = neVersion.NewPath
	}
	if neVersion.Status != "" {
		params["status"] = neVersion.Status
	}
	if neVersion.UpdateBy != "" {
		params["update_by"] = neVersion.UpdateBy
		params["update_time"] = time.Now().UnixMilli()
	}

	// 构建执行语句
	keys, values := repo.KeyValueByUpdate(params)
	sql := "update ne_version set " + strings.Join(keys, ",") + " where id = ?"

	// 执行更新
	values = append(values, neVersion.ID)
	rows, err := datasource.ExecDB("", sql, values)
	if err != nil {
		logger.Errorf("update row : %v", err.Error())
		return 0
	}
	return rows
}

// DeleteByIds 批量删除信息
func (r *NeVersion) DeleteByIds(cmdIds []string) int64 {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	sql := "delete from ne_version where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.ExecDB("", sql, parameters)
	if err != nil {
		logger.Errorf("delete err => %v", err)
		return 0
	}
	return results
}
